<template>
    <div>
        <v-row>
            <v-col>
                <data-table
                    v-model="items"
                    endpoint="api/picks"
                    :title="$tc('pick' , 1)"
                    :filters="filters"
                    :headers="headers"
                    :search-label="searchLabel"
                    ref="datatable"
                >
                    <template v-slot:filters="{ filters , confirmed }">
                        <pick-filters
                            :dates.sync="filters.date"
                            :status.sync="filters.status"
                            :genders.sync="filters.gender"
                            @confirmed="confirmed"
                        ></pick-filters>
                    </template>

                    <template v-slot:item="{ item, index }">
                        <tr>
                            <td>{{ item.created_at | date}}</td>
                            <td>{{ item.user.profile.name }}</td>
                            <td>{{ item.gender.name }}</td>
                            <td>{{ item.sizes }}</td>
                            <td>{{ item.styles }}</td>
                            <td>{{ item.fits }}</td>
                            <td>{{ item.brands }}</td>
                            <td>{{ item.colors }}</td>
                            <td>
                                <v-chip
                                    :color="statusButtonColor(item.status)"
                                    text-color="white"
                                    label
                                >
                                    {{ $t(item.status) }}
                                </v-chip>
                            </td>
                            <td>
                                 <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>

                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                @click="edit(item)"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-col>
        </v-row>

    </div>
</template>

<script>
    import DataTable from "../DataTable";
    import util from "../../../mixins/util"
    import PickFilters from "../filters/PickFilters";
    import { mapMutations } from "vuex";

    export default {
        name: "Pick",
        components: {DataTable, PickFilters},
        mixins: [ util ],
        data: () => ({
            filters: {
                date:[],
                gender: [],
                status: undefined
            },
            items: [],
            deleting: null,
            loading: false,
            dialog: false
        }),

        computed: {
            headers() {
                return [
                    { text: this.$t('pick_at'), value: 'created_at', sortable: false },
                    { text: this.$t('name'), value: 'name', sortable: false },
                    { text: this.$tc('gender', 1), value: 'gender', sortable: false },
                    { text: this.$tc('size', 2), value: 'sizes', sortable: false },
                    { text: this.$tc('style', 2), value: 'styles', sortable: false },
                    { text: this.$tc('fit', 2), value: 'fits', sortable: false },
                    { text: this.$tc('brand', 2), value: 'brands', sortable: false },
                    { text: this.$tc('color', 2), value: 'colors', sortable: false },
                    { text: this.$t('status'), value: 'status', sortable: false },
                    { text: this.$t('action'), value: 'actions', sortable: false },
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('name')
                });
            },

            statuses() {
                return [
                    { text: this.$t('enabled'), value: 1 },
                    { text: this.$t('disabled'), value: 0 }
                ];
            }
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            edit(item) {
                this.$router.push({
                    name: 'pickEdit',
                    params: {
                        id: item.id
                    }
                })
            },
            statusButtonColor(status){
                if(status === 'close') return 'success';
                if(status === 'rejected') return 'error';
                if(status === 'attended') return 'primary';
                if(status === 'pending') return 'warning';
            }
        }
    }
</script>

<style scoped>
</style>
